frontend/controllers/SiteController.php
<?php

namespace frontend\controllers;

use common\models\Log;
use common\models\LoginForm;
use common\models\SendEmailForm;
use common\models\User;
use common\models\Visit;
use frontend\models\PasswordResetRequestForm;
use frontend\models\ResendVerificationEmailForm;
use frontend\models\ResetPasswordForm;
use frontend\models\SignupForm;
use frontend\models\VerifyEmailForm;
use Yii;
use yii\base\InvalidArgumentException;
use yii\web\BadRequestHttpException;
use yii\web\Controller;
use yii\filters\VerbFilter;
use yii\filters\AccessControl;
use yii\base\InvalidParamException;

/**
 * Site controller
 */
class SiteController extends Controller
{
    public function behaviors()
    {
        return [
            'access' => [
                'class' => AccessControl::className(),
                'only' => ['index', 'login', 'logout', 'logout', 'entrance', 'reset-password', 'send-email', 'auth', 'log'],
                'rules' => [
                    [
                        'actions' => ['login', 'logout', 'auth', 'log'],
                        'allow' => true,
                        'roles' => ['?', '@'],
                    ],
                   /* [
                        'allow' => true,
                        'actions' => ['index', 'logout'],
                        'roles' => ['admin'],
                    ],*/
                    [
                        'allow' => true,
                        'actions' => ['about', 'index', 'logout', 'reset-password', 'send-email', 'send-email'],
                        'roles' => ['user'],
                    ],
                ],
            ],
//            'verbs' => [
//                'class' => VerbFilter::className(),
//                'actions' => [
//                    'logout' => ['post'],
//                ],
//            ],
        ];
    }

    public function actions()
    {
        return [
            'error' => [
                'class' => 'yii\web\ErrorAction',
            ],
            'captcha' => [
                'class' => 'yii\captcha\CaptchaAction',
                'fixedVerifyCode' => YII_ENV_TEST ? 'testme' : null,
            ],
        ];
    }

//    public function actionIndex()
//    {
//        return $this->render('index');
//    }

    public function beforeAction($action)
    {
        if ($action->id == 'auth' || $action->id == 'log') {
            $this->enableCsrfValidation = false;
        }

        return parent::beforeAction($action);
    }

    /**
     * login for SM users
     */
    public function actionLog()
    {
        if ($tocken = Yii::$app->request->post('tocken')) {
            $user = User::findOne(['verification_token' => $tocken]);
            if ($user != null) {
                $model = new LoginForm(['scenario' => 'loginApi']);
                $model->email = $user->email;
                $user->verification_token = null;
                $user->save(false);

                $model->login();
                Log::setLog('Вошел в систему', null);

                return $this->goBack();
            } else {
                return $this->redirect(['not-visits']);
            }
        }
    }

    public function actionAuth()
    {
        $this->enableCsrfValidation = false;
        if ($request = Yii::$app->request->post('RM-SB-Authorization')) {
            if ($request == '7(D^xssi|FMga!UC0o^*@A9-*;>Ol{+MliS(|_Qa,Q_lNt2S[$>T*k,q/Vy%V2t' && !empty($email = Yii::$app->request->post('email'))) {
                $user = User::findByEmail($email);
                if ($user) {
                    $user->verification_token = Yii::$app->security->generateRandomString() . '_' . time();
                    if ($user->save(false)) {
                        return $user->verification_token;
                    }

                }
            }
        } else {
                return $this->redirect(['not-visits']);
//            throw new \yii\web\HttpException(401, 'Unauthorized');
        }
    }

    public function actionNotVisits()
    {
        $this->layout = 'empty';
        return $this->render('notVisits');
    }

    public function actionLogin()
    {
        $this->layout = 'login';
        $loginWithEmail = Yii::$app->params['loginWithEmail'];

        if (!Yii::$app->user->isGuest) {
            return $this->goHome();
        }

        $model = $loginWithEmail ? new LoginForm(['scenario' => 'loginWithEmail']) : new LoginForm();

        if ($model->load(Yii::$app->request->post()) && $model->login()) {
            Log::setLog('Вошел в систему', null);

            return $this->goBack();
        } else {
            $model->password = '';
            return $this->render('login', [
                'model' => $model,
            ]);
        }
    }

    public function actionWaiting()
    {
        $this->layout = 'login';

        return $this->render('waiting');
    }

    public function actionSendEmail($email = null)
    {
        $this->layout = 'login';

        $model = new SendEmailForm();

        if ($email != null) {
            $model->email = $email;
            if ($model->sendEmail()) {
                return $this->render('waiting');
            }
        }

        if ($model->load(Yii::$app->request->post())) {
            if ($model->sendEmail()) {
                Yii::$app->getSession()->setFlash('warning', 'Проверьте емейл.');
                return $this->redirect(['/site/waiting']);
//                return $this->goHome();
            } else {
                Yii::$app->getSession()->setFlash('error', 'Невозможно сбросить пароль.');
            }
        }

        return $this->render('sendEmail', [
            'model' => $model,
        ]);
    }

    public function actionLogout()
    {
        Log::setLog('Вышел из системы', null);

        Yii::$app->user->logout();
        Yii::$app->session->destroy();

        return $this->goHome();
    }

    /**
     * Requests password reset.
     *
     * @return mixed
     */
    public function actionRequestPasswordReset()
    {
        $model = new PasswordResetRequestForm();
        if ($model->load(Yii::$app->request->post()) && $model->validate()) {
            if ($model->sendEmail()) {
                Yii::$app->session->setFlash('success', 'Check your email for further instructions.');

                return $this->goHome();
            } else {
                Yii::$app->session->setFlash('error', 'Sorry, we are unable to reset password for the provided email address.');
            }
        }

        return $this->render('requestPasswordResetToken', [
            'model' => $model,
        ]);
    }

    /**
     * Resets password.
     *
     * @param string $token
     * @return mixed
     * @throws BadRequestHttpException
     */
    public function actionResetPassword($token = null)
    {
        $this->layout = 'login';

        try {
            $model = new \common\models\ResetPasswordForm($token);
        } catch (InvalidParamException $e) {
            throw new BadRequestHttpException($e->getMessage());
        }

        if ($model->load(Yii::$app->request->post())) {
            if ($model->validate()) {
                $user = User::findOne(['password_reset_token' => $token]);
                $model->resetPassword();
                Yii::$app->getSession()->setFlash('warning', 'Пароль успешно изменен.');
                $user->is_password_changed = 1;
                $user->save(false);

                return $this->redirect('/site/login');
            }
        }

        return $this->render('resetPassword', [
            'model' => $model,
        ]);
    }

    /**
     * Verify email address
     *
     * @param string $token
     * @return yii\web\Response
     * @throws BadRequestHttpException
     */
    public function actionVerifyEmail($token)
    {
        try {
            $model = new VerifyEmailForm($token);
        } catch (InvalidArgumentException $e) {
            throw new BadRequestHttpException($e->getMessage());
        }
        if ($user = $model->verifyEmail()) {
            if (Yii::$app->user->login($user)) {
                Yii::$app->session->setFlash('success', 'Your email has been confirmed!');
                return $this->goHome();
            }
        }

        Yii::$app->session->setFlash('error', 'Sorry, we are unable to verify your account with provided token.');
        return $this->goHome();
    }

    public function actionSetpassword()
    {
        ini_set('max_execution_time', '900');

        $users = User::find()->where(['role' => 'user'])->all();
        foreach ($users as $user) {
            $user->password_hash = Yii::$app->security->generatePasswordHash($user->email);
            $user->is_password_changed = 0;
            $user->save(false);
        }
        die('eof');
    }

    /**
     * Resend verification email
     *
     * @return mixed
     */
    public function actionResendVerificationEmail()
    {
        $model = new ResendVerificationEmailForm();
        if ($model->load(Yii::$app->request->post()) && $model->validate()) {
            if ($model->sendEmail()) {
                Yii::$app->session->setFlash('success', 'Check your email for further instructions.');
                return $this->goHome();
            }
            Yii::$app->session->setFlash('error', 'Sorry, we are unable to resend verification email for the provided email address.');
        }

        return $this->render('resendVerificationEmail', [
            'model' => $model
        ]);
    }
}

frontend/views/site/contact.php
<?php

/* @var $this yii\web\View */
/* @var $form yii\bootstrap\ActiveForm */
/* @var $model \frontend\models\ContactForm */

use yii\helpers\Html;
use yii\bootstrap\ActiveForm;
use yii\captcha\Captcha;

$this->title = 'Contact';
$this->params['breadcrumbs'][] = $this->title;
?>
<div class="site-contact">
    <h1><?= Html::encode($this->title) ?></h1>

    <p>
        If you have business inquiries or other questions, please fill out the following form to contact us. Thank you.
    </p>

    <div class="row">
        <div class="col-lg-5">
            <?php $form = ActiveForm::begin(['id' => 'contact-form']); ?>

                <?= $form->field($model, 'name')->textInput(['autofocus' => true]) ?>

                <?= $form->field($model, 'email') ?>

                <?= $form->field($model, 'subject') ?>

                <?= $form->field($model, 'body')->textarea(['rows' => 6]) ?>

                <?= $form->field($model, 'verifyCode')->widget(Captcha::className(), [
                    'template' => '<div class="row"><div class="col-lg-3">{image}</div><div class="col-lg-6">{input}</div></div>',
                ]) ?>

                <div class="form-group">
                    <?= Html::submitButton('Submit', ['class' => 'btn btn-primary', 'name' => 'contact-button']) ?>
                </div>

            <?php ActiveForm::end(); ?>
        </div>
    </div>

</div>

frontend/views/site/error.php
<?php

/* @var $this yii\web\View */
/* @var $name string */
/* @var $message string */

/* @var $exception Exception */

use yii\helpers\Html;

$this->title = $name;

?>

<style>
    .site-error {
        min-height: 300px;
    }

    .error-message {
        margin-top: 100px;
        text-align: center;
        font-size: x-large;
    }

</style>

<div class="site-error">

    <h1 class="error-message"><?= 'Ошибка ' . $exception->statusCode . ' ' . nl2br(Html::encode($message)); ?></h1>

</div>

frontend/views/site/index.php
<?php
//
///* @var $this yii\web\View */
//
//$this->title = 'Главная страница';
//
//?>
<!---->
<!--<section class="news">-->
<!--    <div class="container">-->
<!--        <p class="news_title">АКЦИИ/НОВОСТИ</p>-->
<!--        <div class="row">-->
<!--            <div class="col-lg-12">-->
<!--                <div class="grey"></div>-->
<!--            </div>-->
<!--        </div>-->
<!--    </div>-->
<!--</section>-->
<!--<section class="calc">-->
<!--    <div class="container">-->
<!--        <div class="row section-margin">-->
<!--            <div class="col-lg-3">-->
<!--                <p class="calculation-title title-size">КАЛЬКУЛЯТОР БОНУСА</p>-->
<!--                <div class="calculation">-->
<!--                    <div class="pt-3">-->
<!--                        <div class="title-in-calculator">-->
<!--                            <p class="result">Калькулятор бонусов</p>-->
<!--                        </div>-->
<!--                    </div>-->
<!--                    <div class="calc_buttons_wrapper">-->
<!--                        <div class="btn-container">-->
<!--                            <p class="btn-name">Сумма</p>-->
<!--                            <input class="calc_inp" id="sum" autofocus tabindex="1">-->
<!--                        </div>-->
<!--                        <div class="btn-container">-->
<!--                            <p class="btn-name date">Срок накопления</p>-->
<!--                            <input class="calc_inp" id="data" tabindex="2">-->
<!--                        </div>-->
<!--                        <div class="btn-container">-->
<!--                            <p class="btn-name">Процент</p>-->
<!--                            <input class="calc_inp" id="percent" tabindex="3">-->
<!--                        </div>-->
<!--                        <div class="btn-container">-->
<!--                            <p class="btn-name">Бонус</p>-->
<!--                            <input class="calc_inp" id="bonus" tabindex="4">-->
<!--                        </div>-->
<!--                    </div>-->
<!--                </div>-->
<!--            </div>-->
<!--            <div class="col-lg-6 col-sm-12 ml-auto achievement-container">-->
<!--                <p class="achievement-title text-center title-size">ВАШЕ ПОСЛЕДНЕЕ ДОСТИЖЕНИЕ</p>-->
<!--                <div class="row achievement">-->
<!---->
<!--                    <div class="col-lg-6 col-sm-12 kitty">-->
<!--                        <img class="kitty_img" src="img/kitty.png" alt="">-->
<!--                    </div>-->
<!--                    <div class="col-lg-6"><p class="achievement_description">У вас еще нету достижений! <br> Измените-->
<!--                            это прямо сейчас</p></div>-->
<!--                </div>-->
<!--            </div>-->
<!--        </div>-->
<!--    </div>-->
<!--</section>-->
<!--<section class="visits-table">-->
<!--    <div class="container">-->
<!--        <div class="row section-margin">-->
<!--            <div class="col-lg-3">-->
<!--                <p class="title-size">ТАБЛИЦА ВИЗИТОВ</p>-->
<!--            </div>-->
<!--            <div class="col-lg-3 ml-auto">-->
<!--                <button class="download-file"> Загрузить</button>-->
<!--            </div>-->
<!--        </div>-->
<!--        <div class="row">-->
<!--            <div class="col-lg-12">-->
<!--                <table class="table-with-visits">-->
<!--                    <tr class="lite-green">-->
<!--                        <th class="titles">Дата визита</th>-->
<!--                        <th class="titles">Номер анкеты</th>-->
<!--                        <th class="titles">Проект</th>-->
<!--                        <th class="titles">Адрес локации</th>-->
<!--                        <th class="titles">Сумма</th>-->
<!--                        <th class="titles">Бонус</th>-->
<!--                        <th class="titles">Статус визита</th>-->
<!--                        <th class="titles">Управление средствами</th>-->
<!--                    </tr>-->
<!--                    <tr>-->
<!--                        <td class="titles_items">05.09.18</td>-->
<!--                        <td class="titles_items">63834936</td>-->
<!--                        <td class="titles_items">Лукойл</td>-->
<!--                        <td class="titles_items">ул. Руденко 41</td>-->
<!--                        <td class="titles_items">500</td>-->
<!--                        <td class="titles_items">01.12.2018 <p>сумма составит:</p>-->
<!--                            <p class="price">600 RUB</p></td>-->
<!--                        <td class="titles_items">Проверка</td>-->
<!--                        <td class="titles_items">—</td>-->
<!--                    </tr>-->
<!--                    <tr class="light-grren">-->
<!--                        <td class="titles_items">05.09.18</td>-->
<!--                        <td class="titles_items">63834936</td>-->
<!--                        <td class="titles_items">Лукойл</td>-->
<!--                        <td class="titles_items">ул. Руденко 41</td>-->
<!--                        <td class="titles_items">500</td>-->
<!--                        <td class="titles_items">01.12.2018 <p>сумма составит:</p>-->
<!--                            <p class="price">600 RUB</p></td>-->
<!--                        <td class="titles_items">Проверка</td>-->
<!--                        <td class="titles_items">—</td>-->
<!--                    </tr>-->
<!--                    <tr>-->
<!--                        <td class="titles_items">05.09.18</td>-->
<!--                        <td class="titles_items">63834936</td>-->
<!--                        <td class="titles_items">Лукойл</td>-->
<!--                        <td class="titles_items">ул. Руденко 41</td>-->
<!--                        <td class="titles_items">500</td>-->
<!--                        <td class="titles_items">01.12.2018 <p>сумма составит:</p>-->
<!--                            <p class="price">600 RUB</p></td>-->
<!--                        <td class="titles_items">Проверка</td>-->
<!--                        <td class="titles_items">Накопление</td>-->
<!--                    </tr>-->
<!--                    <tr class="light-grren">-->
<!--                        <td class="titles_items">05.09.18</td>-->
<!--                        <td class="titles_items">63834936</td>-->
<!--                        <td class="titles_items">Лукойл</td>-->
<!--                        <td class="titles_items">ул. Руденко 41</td>-->
<!--                        <td class="titles_items">500</td>-->
<!--                        <td class="titles_items">01.12.2018 <p>сумма составит:</p>-->
<!--                            <p class="price">600 RUB</p></td>-->
<!--                        <td class="titles_items">Проверка</td>-->
<!--                        <td class="titles_items">—</td>-->
<!--                    </tr>-->
<!--                    <tr>-->
<!--                        <td class="titles_items">05.09.18</td>-->
<!--                        <td class="titles_items">63834936</td>-->
<!--                        <td class="titles_items">Лукойл</td>-->
<!--                        <td class="titles_items">ул. Руденко 41</td>-->
<!--                        <td class="titles_items">500</td>-->
<!--                        <td class="titles_items">01.12.2018 <p>сумма составит:</p>-->
<!--                            <p class="price">600 RUB</p></td>-->
<!--                        <td class="titles_items">Проверка</td>-->
<!--                        <td class="titles_items">—</td>-->
<!--                    </tr>-->
<!--                    <tr class="light-grren">-->
<!--                        <td class="titles_items">05.09.18</td>-->
<!--                        <td class="titles_items">63834936</td>-->
<!--                        <td class="titles_items">Лукойл</td>-->
<!--                        <td class="titles_items">ул. Руденко 41</td>-->
<!--                        <td class="titles_items">500</td>-->
<!--                        <td class="titles_items">01.12.2018 <p>сумма составит:</p>-->
<!--                            <p class="price">600 RUB</p></td>-->
<!--                        <td class="titles_items">Проверка</td>-->
<!--                        <td class="titles_items">—</td>-->
<!--                    </tr>-->
<!--                </table>-->
<!--            </div>-->
<!--        </div>-->
<!--    </div>-->
<!--</section>-->

frontend/views/site/login.php
<?php

/* @var $this yii\web\View */
/* @var $form yii\bootstrap\ActiveForm */

/* @var $model \common\models\LoginForm */

use yii\helpers\Html;
use yii\bootstrap\ActiveForm;

?>

<?php $form = ActiveForm::begin(
    [
        'options' => [
            'class' => 'login-main-form'
        ],
    ]
); ?>

<?php if ($model->scenario === 'loginWithEmail') { ?>
    <label class="login-container"><input class="enter-login login-data" type="text" name="LoginForm[email]"></label>
<?php } else { ?>
    <label class="login-container"><input class="enter-login login-data" type="text" name="LoginForm[username]"></label>
<?php } ?>
<label class="password-container"><input class="password login-data" type="password" name="LoginForm[password]"></label>
<input type="checkbox" class="form-check-input" id="сheck-me" name="LoginForm[rememberMe]">
<label class="remember" for="сheck-me">Запомнить меня</label>
<?= $form->field($model, 'rememberMe')->hiddenInput(['class' => 'form-control'])->label(false, ['class' => 'label-class']) ?>

<div class="green-button-wrapp">
    <?= Html::submitButton('Войти', ['class' => 'green__button', 'name' => 'login-button']) ?>
</div>

<?= Html::a('Забыли пароль?', ['/site/send-email']) ?>

<?php ActiveForm::end(); ?>

frontend/views/site/notVisits.php
<?php


?>

    <style>
        h3.centerText {
            text-align: center;
            margin: 2em;
            font-size: 2.2rem;
            font-weight: bold;
            color: #69896a;
        }
        .blockNoVisit {
            min-height: 65vh;
        }
        .center-text, .noVisittext {
            font-size: 2rem;
            color: #69896a;
            font-weight: bold;
        }
    </style>
    <div class="container">
        <div class="blockNoVisit">
            <h3 class="centerText">У вас нет выполненных визитов</h3>
            <p class="noVisittext">Программа "Шоппер бонус" станет доступной после совершения любого визита</p>
        </div>

    </div>

frontend/views/site/requestPasswordResetToken.php
<?php

/* @var $this yii\web\View */
/* @var $form yii\bootstrap\ActiveForm */
/* @var $model \frontend\models\PasswordResetRequestForm */

use yii\helpers\Html;
use yii\bootstrap\ActiveForm;

$this->title = 'Request password reset';
$this->params['breadcrumbs'][] = $this->title;
?>
<div class="site-request-password-reset">
    <h1><?= Html::encode($this->title) ?></h1>

    <p>Please fill out your email. A link to reset password will be sent there.</p>

    <div class="row">
        <div class="col-lg-5">
            <?php $form = ActiveForm::begin(['id' => 'request-password-reset-form']); ?>

                <?= $form->field($model, 'email')->textInput(['autofocus' => true]) ?>

                <div class="form-group">
                    <?= Html::submitButton('Send', ['class' => 'btn btn-primary']) ?>
                </div>

            <?php ActiveForm::end(); ?>
        </div>
    </div>
</div>

frontend/views/site/resendVerificationEmail.php
<?php
/* @var $this yii\web\View */
/* @var $form yii\bootstrap\ActiveForm */
/* @var $model \frontend\models\ResetPasswordForm */

use yii\helpers\Html;
use yii\bootstrap\ActiveForm;

$this->title = 'Resend verification email';
$this->params['breadcrumbs'][] = $this->title;
?>
<div class="site-resend-verification-email">
    <h1><?= Html::encode($this->title) ?></h1>

    <p>Please fill out your email. A verification email will be sent there.</p>

    <div class="row">
        <div class="col-lg-5">
            <?php $form = ActiveForm::begin(['id' => 'resend-verification-email-form']); ?>

            <?= $form->field($model, 'email')->textInput(['autofocus' => true]) ?>

            <div class="form-group">
                <?= Html::submitButton('Send', ['class' => 'btn btn-primary']) ?>
            </div>

            <?php ActiveForm::end(); ?>
        </div>
    </div>
</div>

frontend/views/site/resetPassword.php
<?php

use yii\helpers\Html;
use yii\widgets\ActiveForm;

/* @var $this yii\web\View */
/* @var $model common\models\ResetPasswordForm */
/* @var $form ActiveForm */
?>
<div class="site-resetPassword" style="padding: 20px">

    <?php $form = ActiveForm::begin(); ?>

    <?= $form->field($model, 'password')->label('Укажите новый пароль') ?>

    <div class="green-button-wrapp">
        <?= Html::submitButton('Изменить', ['class' => 'green__button']) ?>
    </div>

    <?php ActiveForm::end(); ?>

</div><!-- site-resetPassword -->

frontend/views/site/sendEmail.php
<?php

use yii\helpers\Html;
use yii\widgets\ActiveForm;

/* @var $this yii\web\View */
/* @var $model common\models\SendEmailForm */
/* @var $form ActiveForm */
?>
<div class="site-sendEmail" style="padding: 20px 20px">

    <p>Необходимо ввести e-mail пользователя:</p>

    <?php $form = ActiveForm::begin(); ?>

    <?= $form->field($model, 'email')->label(false) ?>

    <div class="green-button-wrapp">
        <?= Html::submitButton('Отправить', ['class' => 'green__button']) ?>
    </div>

    <?php ActiveForm::end(); ?>

</div><!-- site-sendEmail -->

frontend/views/site/signup.php
<?php

/* @var $this yii\web\View */
/* @var $form yii\bootstrap\ActiveForm */
/* @var $model \frontend\models\SignupForm */

use yii\helpers\Html;
use yii\bootstrap\ActiveForm;

$this->title = 'Signup';
$this->params['breadcrumbs'][] = $this->title;
?>
<div class="site-signup">
    <h1><?= Html::encode($this->title) ?></h1>

    <p>Please fill out the following fields to signup:</p>

    <div class="row">
        <div class="col-lg-5">
            <?php $form = ActiveForm::begin(['id' => 'form-signup']); ?>

                <?= $form->field($model, 'username')->textInput(['autofocus' => true]) ?>

                <?= $form->field($model, 'email') ?>

                <?= $form->field($model, 'password')->passwordInput() ?>

                <div class="form-group">
                    <?= Html::submitButton('Signup', ['class' => 'btn btn-primary', 'name' => 'signup-button']) ?>
                </div>

            <?php ActiveForm::end(); ?>
        </div>
    </div>
</div>

frontend/views/site/waiting.php
<?php

/* @var $this yii\web\View */
/* @var $form yii\bootstrap\ActiveForm */

/* @var $model \common\models\LoginForm */

use yii\helpers\Html;
use yii\bootstrap\ActiveForm;

?>

<h3>Перейдите по ссылке из письма</h3>